# $Id: Tool.py,v 1.8 2005/12/17 16:56:22 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidgetDeliciousTools/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.8 $"
__date__       = "$Date: 2005/12/17 16:56:22 $"
__copyright__  = "Copyright (c) 2005-2006 Aaron Straup Cope."
__license__    = "GNU GPL 2"

import wx
import delicious
import thread

from ImageWidget.Login import ImageWidgetLogin
from ImageWidgetDeliciousTool.Constants import *

class DeliciousTool :
    
    def Setup (self,frame) :

        self.delicious_lock       = thread.allocate_lock()
        self.delicious_photo_urls = []

	DelMenu = wx.Menu()
        
	DelMenu.Append(DELICIOUS_ID_POST,
		       DELICIOUS_MENU_POST,
		       DELICIOUS_DESCRIBE_POST)

	DelMenu.Append(DELICIOUS_ID_EDITLOGIN,
		       DELICIOUS_MENU_EDITLOGIN,
		       DELICIOUS_DESCRIBE_EDITLOGIN)

	wx.EVT_MENU(frame,DELICIOUS_ID_POST,
		    self.PostToDelicious);

	wx.EVT_MENU(frame,
		    DELICIOUS_ID_EDITLOGIN,
		    self.EditDeliciousLogin);

	menu  = frame.GetMenuBar();
	menu.Append(DelMenu,DELICIOUS_MENU_LABEL)

	#

	cfg = self.Config()
	ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

	cfg.EnsureStubProperty(ns[DELICIOUS_CFG_USERNAME])
	cfg.EnsureStubProperty(ns[DELICIOUS_CFG_PASSWORD])
	
    #
    #
    #
    
    def DeliciousKeyDown (self,key,event=None) :

	if key == "D" :

	    if event==None:
		return True

	    if event.ShiftDown() :
		self.EditDeliciousLogin()
	    else :
		self.PostToDelicious(event)	
	else :
	    return False

    #
    #
    #
    
    def DeliciousTags (self) :
	return ""

    #
    # FIX ME : allow user defined title strings
    #
    
    def PostToDelicious (self,event,fmt=u"[%s] %s") :

	try :
	    photo = self.GetCurrentPhoto()
	except Exception, e:
	    self.ReportError(e)
	    return False

	# User info

	[user,pswd] = self.GetDeliciousLogin()

	if ((user==u"") or (pswd==u"")) :
	    [user,pswd] = self.EditDeliciousLogin()

	#

	title = fmt % (photo['creator'],photo['title']);
	tags  = self.DeliciousTags()

        if self.SetURLPending(photo['url']) :
            thread.start_new_thread(self.SendToDelicious,(user, pswd, photo['url'], title, tags))

    #
    #
    #

    def SetURLPending (self, url) :
        self.ReportActivity(DELICIOUS_MSG_POSTING)

        self.delicious_lock.acquire()
        post_pending = url in self.delicious_photo_urls

        if post_pending == False :
            self.delicious_photo_urls.append(url)

        self.delicious_lock.release()

        if post_pending :
            return False
        else :
            return True
    
    #
    #
    #
    
    def UnsetURLPending (self, url) :
        self.delicious_lock.acquire()
        self.delicious_photo_urls.remove(url)
        self.delicious_lock.release()

    #
    #
    #
    
    def SendToDelicious (self, user, pswd, url, title, tags ) :
	try :
	    delicious.add(user,pswd,url,title,'',tags);
            self.UnsetURLPending(url)
	    self.ReportActivity(DELICIOUS_MSG_POSTED);
	except Exception, e :
            self.UnsetURLPending(url)            
	    self.ReportError(DELICIOUS_MSG_NOTPOSTED % e);

    #
    #
    #
    
    def GetDeliciousLogin (self) :
	cfg = self.Config()
	ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

	user = cfg.GetPref(ns[DELICIOUS_CFG_USERNAME])
	pswd = cfg.GetPref(ns[DELICIOUS_CFG_PASSWORD])

	return [user,pswd]

    #
    #
    #
    
    def EditDeliciousLogin (self,event=None) :

	[user,pswd] = self.GetDeliciousLogin()

	frame = self.GetTopWindow()
	auth  = ImageWidgetLogin(frame,-1,DELICIOUS_LOGIN_TITLE,user,pswd)

	(x,y) = frame.GetPosition()
	auth.SetPosition((x + 50,y + 50))
	    
	auth.ShowModal()
	input = auth.result
	
	if input :
		
	    user = input['user']
	    pswd = input['pswd']
		
	    if input['save'] :
		cfg = self.Config()
		ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

		cfg.SetPref(ns[DELICIOUS_CFG_USERNAME],user)
		cfg.SetPref(ns[DELICIOUS_CFG_PASSWORD],pswd)
		cfg.Save()
		    
	auth.Destroy()
	return [user,pswd]
